
/* Copyright 2006 Edward C. Jones

   This file is part of mrquery.

   mrquery is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2 of the License, or (at your option)
   any later version.

   mrquery is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
   more details.

   You should have received a copy of the GNU General Public License along
   with mrquery; if not, write to the Free Software Foundation, Inc., 51
   Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
*/

#include </usr/local/include/python2.4/Python.h>
#include </usr/local/include/python2.4/numarray/numarray.h>
#include <math.h>
#include <string.h>
#include <stdio.h>
#include <time.h>

#define min(a, b) ((a) < (b)) ? (a) : (b)
#define max(a, b) ((a) > (b)) ? (a) : (b)

#define LAYERS 3
#define RCQUOTA 40
#define HAARSIZE 128
/* M_SQRT1_2  1/sqrt(2) from math.h */

#define POW2(n) (1 << (n))

#define PIX1(arr, x, TYPE) (*(((TYPE*) NA_OFFSETDATA(arr)) + (x)))

#define PIX2(arr, x, y, TYPE) (*(((TYPE*) NA_OFFSETDATA(arr)) + \
       (x) * arr->dimensions[1] + (y)))

#define PIX3(arr, x, y, z, TYPE) (*(((TYPE*) NA_OFFSETDATA(arr)) + \
   (x) * arr->dimensions[1] * arr->dimensions[2] + \
   (y) * arr->dimensions[2] + (z)))
